##// END OF EJS Templates
remove DISABLE_FBI
Unknown -
r251:3df8dd683731
parent child
Show More
@@ -1,671 +1,663
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49 RPI3B_DTB_FILE=${RPI3B_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
50 50 RPI3B_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
51 51
52 52 # Debian release
53 53 RELEASE=${RELEASE:=jessie}
54 54 KERNEL_ARCH=${KERNEL_ARCH:=arm}
55 55 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
56 56 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
57 57 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
58 58 if [ "$KERNEL_ARCH" = "arm64" ] ; then
59 59 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
60 60 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
61 61 else
62 62 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
63 63 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
64 64 fi
65 65 if [ "$RELEASE_ARCH" = "arm64" ] ; then
66 66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
67 67 else
68 68 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
69 69 fi
70 70 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
71 71
72 72 # URLs
73 73 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
74 74 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
75 75 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
76 76 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
77 77 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
78 78 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
79 79
80 80 # Build directories
81 81 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
82 82 BUILDDIR="${BASEDIR}/build"
83 83
84 84 # Prepare date string for default image file name
85 85 DATE="$(date +%Y-%m-%d)"
86 86 if [ -z "$KERNEL_BRANCH" ] ; then
87 87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 88 else
89 89 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
90 90 fi
91 91
92 92 # Chroot directories
93 93 R="${BUILDDIR}/chroot"
94 94 ETC_DIR="${R}/etc"
95 95 LIB_DIR="${R}/lib"
96 96 BOOT_DIR="${R}/boot/firmware"
97 97 KERNEL_DIR="${R}/usr/src/linux"
98 98 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
99 99
100 100 # Firmware directory: Blank if download from github
101 101 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
102 102
103 103 # General settings
104 104 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
105 105 PASSWORD=${PASSWORD:=raspberry}
106 106 USER_PASSWORD=${USER_PASSWORD:=raspberry}
107 107 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
108 108 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
109 109 EXPANDROOT=${EXPANDROOT:=true}
110 110
111 111 # Keyboard settings
112 112 XKB_MODEL=${XKB_MODEL:=""}
113 113 XKB_LAYOUT=${XKB_LAYOUT:=""}
114 114 XKB_VARIANT=${XKB_VARIANT:=""}
115 115 XKB_OPTIONS=${XKB_OPTIONS:=""}
116 116
117 117 # Network settings (DHCP)
118 118 ENABLE_DHCP=${ENABLE_DHCP:=true}
119 119
120 120 # Network settings (static)
121 121 NET_ADDRESS=${NET_ADDRESS:=""}
122 122 NET_GATEWAY=${NET_GATEWAY:=""}
123 123 NET_DNS_1=${NET_DNS_1:=""}
124 124 NET_DNS_2=${NET_DNS_2:=""}
125 125 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
126 126 NET_NTP_1=${NET_NTP_1:=""}
127 127 NET_NTP_2=${NET_NTP_2:=""}
128 128
129 129 # APT settings
130 130 APT_PROXY=${APT_PROXY:=""}
131 131 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
132 132
133 133 # Feature settings
134 134 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
135 135 ENABLE_I2C=${ENABLE_I2C:=false}
136 136 ENABLE_SPI=${ENABLE_SPI:=false}
137 137 ENABLE_IPV6=${ENABLE_IPV6:=true}
138 138 ENABLE_SSHD=${ENABLE_SSHD:=true}
139 139 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
140 140 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
141 141 ENABLE_SOUND=${ENABLE_SOUND:=true}
142 142 ENABLE_DBUS=${ENABLE_DBUS:=true}
143 143 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
144 144 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
145 145 ENABLE_XORG=${ENABLE_XORG:=false}
146 146 ENABLE_WM=${ENABLE_WM:=""}
147 147 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
148 148 ENABLE_USER=${ENABLE_USER:=true}
149 149 USER_NAME=${USER_NAME:="pi"}
150 150 ENABLE_ROOT=${ENABLE_ROOT:=false}
151 151
152 152 # SSH settings
153 153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
154 154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
155 155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
156 156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
157 157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
158 158
159 159 # Advanced settings
160 160 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
161 161 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
162 162 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
163 163 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
164 164 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
165 165 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
166 166 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
167 167 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
168 168 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
169 169 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
170 170 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
171 171 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
172 172
173 173 # Kernel compilation settings
174 174 BUILD_KERNEL=${BUILD_KERNEL:=false}
175 175 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
176 176 KERNEL_THREADS=${KERNEL_THREADS:=1}
177 177 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
178 178 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
179 179 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
180 180 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
181 181 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
182 182
183 183 if [ "$KERNEL_ARCH" = "arm64" ] ; then
184 184 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
185 185 else
186 186 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
187 187 fi
188 188
189 189 # Kernel compilation from source directory settings
190 190 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
191 191 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
192 192 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
193 193 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
194 194
195 195 # Reduce disk usage settings
196 196 REDUCE_APT=${REDUCE_APT:=true}
197 197 REDUCE_DOC=${REDUCE_DOC:=true}
198 198 REDUCE_MAN=${REDUCE_MAN:=true}
199 199 REDUCE_VIM=${REDUCE_VIM:=false}
200 200 REDUCE_BASH=${REDUCE_BASH:=false}
201 201 REDUCE_HWDB=${REDUCE_HWDB:=true}
202 202 REDUCE_SSHD=${REDUCE_SSHD:=true}
203 203 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
204 204
205 205 # Encrypted filesystem settings
206 206 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
207 207 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
208 208 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
209 209 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
210 210 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
211 211
212 # Stop the Crypto Wars
213 DISABLE_FBI=${DISABLE_FBI:=false}
214
215 212 # Chroot scripts directory
216 213 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
217 214
218 215 # Packages required in the chroot build environment
219 216 APT_INCLUDES=${APT_INCLUDES:=""}
220 217 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
221 218
222 219 # Packages required for bootstrapping
223 220 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
224 221 MISSING_PACKAGES=""
225 222
226 223 # Packages installed for c/c++ build environment in chroot (keep empty)
227 224 COMPILER_PACKAGES=""
228 225
229 226 set +x
230 227
231 228 # Set Raspberry Pi model specific configuration
232 229 if [ "$RPI_MODEL" = 2 ] ; then
233 230 DTB_FILE=${RPI2_DTB_FILE}
234 231 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
235 232 elif [ "$RPI_MODEL" = 3 ] ; then
236 233 DTB_FILE=${RPI3_DTB_FILE}
237 234 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
238 235 BUILD_KERNEL=true
239 236 elif [ "$RPI_MODEL" = 3B ] ; then
240 237 DTB_FILE=${RPI3B_DTB_FILE}
241 238 UBOOT_CONFIG=${RPI3B_UBOOT_CONFIG}
242 239 BUILD_KERNEL=true
243 240 else
244 241 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
245 242 exit 1
246 243 fi
247 244
248 245 # Check if the internal wireless interface is supported by the RPi model
249 246 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
250 247 echo "error: The selected Raspberry Pi model has no internal wireless interface"
251 248 exit 1
252 249 fi
253 250
254 251 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
255 252 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
256 253 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
257 254 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
258 255 exit 1
259 256 fi
260 257 fi
261 258
262 259 # Build RPi2/3 Linux kernel if required by Debian release
263 260 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
264 261 BUILD_KERNEL=true
265 262 fi
266 263
267 264 # Add packages required for kernel cross compilation
268 265 if [ "$BUILD_KERNEL" = true ] ; then
269 266 if [ "$KERNEL_ARCH" = "arm" ] ; then
270 267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
271 268 else
272 269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
273 270 fi
274 271 fi
275 272
276 273 # Add libncurses5 to enable kernel menuconfig
277 274 if [ "$KERNEL_MENUCONFIG" = true ] ; then
278 275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
279 276 fi
280 277
281 278 # Add ccache compiler cache for (faster) kernel cross (re)compilation
282 279 if [ "$KERNEL_CCACHE" = true ] ; then
283 280 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
284 281 fi
285 282
286 # Stop the Crypto Wars
287 if [ "$DISABLE_FBI" = true ] ; then
288 ENABLE_CRYPTFS=true
289 fi
290
291 283 # Add cryptsetup package to enable filesystem encryption
292 284 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
293 285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
294 286 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
295 287
296 288 if [ -z "$CRYPTFS_PASSWORD" ] ; then
297 289 echo "error: no password defined (CRYPTFS_PASSWORD)!"
298 290 exit 1
299 291 fi
300 292 ENABLE_INITRAMFS=true
301 293 fi
302 294
303 295 # Add initramfs generation tools
304 296 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
305 297 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
306 298 fi
307 299
308 300 # Add device-tree-compiler required for building the U-Boot bootloader
309 301 if [ "$ENABLE_UBOOT" = true ] ; then
310 302 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
311 303 fi
312 304
313 305 # Check if root SSH (v2) public key file exists
314 306 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
315 307 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
316 308 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
317 309 exit 1
318 310 fi
319 311 fi
320 312
321 313 # Check if $USER_NAME SSH (v2) public key file exists
322 314 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
323 315 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
324 316 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
325 317 exit 1
326 318 fi
327 319 fi
328 320
329 321 # Check if all required packages are installed on the build system
330 322 for package in $REQUIRED_PACKAGES ; do
331 323 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
332 324 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
333 325 fi
334 326 done
335 327
336 328 # If there are missing packages ask confirmation for install, or exit
337 329 if [ -n "$MISSING_PACKAGES" ] ; then
338 330 echo "the following packages needed by this script are not installed:"
339 331 echo "$MISSING_PACKAGES"
340 332
341 333 echo -n "\ndo you want to install the missing packages right now? [y/n] "
342 334 read confirm
343 335 [ "$confirm" != "y" ] && exit 1
344 336
345 337 # Make sure all missing required packages are installed
346 338 apt-get -qq -y install ${MISSING_PACKAGES}
347 339 fi
348 340
349 341 # Check if ./bootstrap.d directory exists
350 342 if [ ! -d "./bootstrap.d/" ] ; then
351 343 echo "error: './bootstrap.d' required directory not found!"
352 344 exit 1
353 345 fi
354 346
355 347 # Check if ./files directory exists
356 348 if [ ! -d "./files/" ] ; then
357 349 echo "error: './files' required directory not found!"
358 350 exit 1
359 351 fi
360 352
361 353 # Check if specified KERNELSRC_DIR directory exists
362 354 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
363 355 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
364 356 exit 1
365 357 fi
366 358
367 359 # Check if specified UBOOTSRC_DIR directory exists
368 360 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
369 361 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
370 362 exit 1
371 363 fi
372 364
373 365 # Check if specified FBTURBOSRC_DIR directory exists
374 366 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
375 367 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
376 368 exit 1
377 369 fi
378 370
379 371 # Check if specified CHROOT_SCRIPTS directory exists
380 372 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
381 373 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
382 374 exit 1
383 375 fi
384 376
385 377 # Check if specified device mapping already exists (will be used by cryptsetup)
386 378 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
387 379 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
388 380 exit 1
389 381 fi
390 382
391 383 # Don't clobber an old build
392 384 if [ -e "$BUILDDIR" ] ; then
393 385 echo "error: directory ${BUILDDIR} already exists, not proceeding"
394 386 exit 1
395 387 fi
396 388
397 389 # Setup chroot directory
398 390 mkdir -p "${R}"
399 391
400 392 # Check if build directory has enough of free disk space >512MB
401 393 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
402 394 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
403 395 exit 1
404 396 fi
405 397
406 398 set -x
407 399
408 400 # Call "cleanup" function on various signals and errors
409 401 trap cleanup 0 1 2 3 6
410 402
411 403 # Add required packages for the minbase installation
412 404 if [ "$ENABLE_MINBASE" = true ] ; then
413 405 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
414 406 fi
415 407
416 408 # Add required locales packages
417 409 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
418 410 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
419 411 fi
420 412
421 413 # Add parted package, required to get partprobe utility
422 414 if [ "$EXPANDROOT" = true ] ; then
423 415 APT_INCLUDES="${APT_INCLUDES},parted"
424 416 fi
425 417
426 418 # Add dbus package, recommended if using systemd
427 419 if [ "$ENABLE_DBUS" = true ] ; then
428 420 APT_INCLUDES="${APT_INCLUDES},dbus"
429 421 fi
430 422
431 423 # Add iptables IPv4/IPv6 package
432 424 if [ "$ENABLE_IPTABLES" = true ] ; then
433 425 APT_INCLUDES="${APT_INCLUDES},iptables"
434 426 fi
435 427
436 428 # Add openssh server package
437 429 if [ "$ENABLE_SSHD" = true ] ; then
438 430 APT_INCLUDES="${APT_INCLUDES},openssh-server"
439 431 fi
440 432
441 433 # Add alsa-utils package
442 434 if [ "$ENABLE_SOUND" = true ] ; then
443 435 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
444 436 fi
445 437
446 438 # Add rng-tools package
447 439 if [ "$ENABLE_HWRANDOM" = true ] ; then
448 440 APT_INCLUDES="${APT_INCLUDES},rng-tools"
449 441 fi
450 442
451 443 # Add fbturbo video driver
452 444 if [ "$ENABLE_FBTURBO" = true ] ; then
453 445 # Enable xorg package dependencies
454 446 ENABLE_XORG=true
455 447 fi
456 448
457 449 # Add user defined window manager package
458 450 if [ -n "$ENABLE_WM" ] ; then
459 451 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
460 452
461 453 # Enable xorg package dependencies
462 454 ENABLE_XORG=true
463 455 fi
464 456
465 457 # Add xorg package
466 458 if [ "$ENABLE_XORG" = true ] ; then
467 459 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
468 460 fi
469 461
470 462 # Replace selected packages with smaller clones
471 463 if [ "$ENABLE_REDUCE" = true ] ; then
472 464 # Add levee package instead of vim-tiny
473 465 if [ "$REDUCE_VIM" = true ] ; then
474 466 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
475 467 fi
476 468
477 469 # Add dropbear package instead of openssh-server
478 470 if [ "$REDUCE_SSHD" = true ] ; then
479 471 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
480 472 fi
481 473 fi
482 474
483 475 if [ "$RELEASE" != "jessie" ] ; then
484 476 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
485 477 fi
486 478
487 479 # Configure kernel sources if no KERNELSRC_DIR
488 480 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
489 481 KERNELSRC_CONFIG=true
490 482 fi
491 483
492 484 # Configure reduced kernel
493 485 if [ "$KERNEL_REDUCE" = true ] ; then
494 486 KERNELSRC_CONFIG=false
495 487 fi
496 488
497 489 # Execute bootstrap scripts
498 490 for SCRIPT in bootstrap.d/*.sh; do
499 491 head -n 3 "$SCRIPT"
500 492 . "$SCRIPT"
501 493 done
502 494
503 495 ## Execute custom bootstrap scripts
504 496 if [ -d "custom.d" ] ; then
505 497 for SCRIPT in custom.d/*.sh; do
506 498 . "$SCRIPT"
507 499 done
508 500 fi
509 501
510 502 # Execute custom scripts inside the chroot
511 503 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
512 504 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
513 505 chroot_exec /bin/bash -x <<'EOF'
514 506 for SCRIPT in /chroot_scripts/* ; do
515 507 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
516 508 $SCRIPT
517 509 fi
518 510 done
519 511 EOF
520 512 rm -rf "${R}/chroot_scripts"
521 513 fi
522 514
523 515 # Remove c/c++ build environment from the chroot
524 516 chroot_remove_cc
525 517
526 518 # Remove apt-utils
527 519 if [ "$RELEASE" = "jessie" ] ; then
528 520 chroot_exec apt-get purge -qq -y --force-yes apt-utils
529 521 fi
530 522
531 523 # Generate required machine-id
532 524 MACHINE_ID=$(dbus-uuidgen)
533 525 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
534 526 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
535 527
536 528 # APT Cleanup
537 529 chroot_exec apt-get -y clean
538 530 chroot_exec apt-get -y autoclean
539 531 chroot_exec apt-get -y autoremove
540 532
541 533 # Unmount mounted filesystems
542 534 umount -l "${R}/proc"
543 535 umount -l "${R}/sys"
544 536
545 537 # Clean up directories
546 538 rm -rf "${R}/run/*"
547 539 rm -rf "${R}/tmp/*"
548 540
549 541 # Clean up files
550 542 rm -f "${ETC_DIR}/ssh/ssh_host_*"
551 543 rm -f "${ETC_DIR}/dropbear/dropbear_*"
552 544 rm -f "${ETC_DIR}/apt/sources.list.save"
553 545 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
554 546 rm -f "${ETC_DIR}/*-"
555 547 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
556 548 rm -f "${ETC_DIR}/resolv.conf"
557 549 rm -f "${R}/root/.bash_history"
558 550 rm -f "${R}/var/lib/urandom/random-seed"
559 551 rm -f "${R}/initrd.img"
560 552 rm -f "${R}/vmlinuz"
561 553 rm -f "${R}${QEMU_BINARY}"
562 554
563 555 # Calculate size of the chroot directory in KB
564 556 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
565 557
566 558 # Calculate the amount of needed 512 Byte sectors
567 559 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
568 560 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
569 561 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
570 562
571 563 # The root partition is EXT4
572 564 # This means more space than the actual used space of the chroot is used.
573 565 # As overhead for journaling and reserved blocks 35% are added.
574 566 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
575 567
576 568 # Calculate required image size in 512 Byte sectors
577 569 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
578 570
579 571 # Prepare image file
580 572 if [ "$ENABLE_SPLITFS" = true ] ; then
581 573 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
582 574 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
583 575 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
584 576 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
585 577
586 578 # Write firmware/boot partition tables
587 579 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
588 580 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
589 581 EOM
590 582
591 583 # Write root partition table
592 584 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
593 585 ${TABLE_SECTORS},${ROOT_SECTORS},83
594 586 EOM
595 587
596 588 # Setup temporary loop devices
597 589 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
598 590 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
599 591 else # ENABLE_SPLITFS=false
600 592 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
601 593 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
602 594
603 595 # Write partition table
604 596 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
605 597 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
606 598 ${ROOT_OFFSET},${ROOT_SECTORS},83
607 599 EOM
608 600
609 601 # Setup temporary loop devices
610 602 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
611 603 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
612 604 fi
613 605
614 606 if [ "$ENABLE_CRYPTFS" = true ] ; then
615 607 # Create dummy ext4 fs
616 608 mkfs.ext4 "$ROOT_LOOP"
617 609
618 610 # Setup password keyfile
619 611 touch .password
620 612 chmod 600 .password
621 613 echo -n ${CRYPTFS_PASSWORD} > .password
622 614
623 615 # Initialize encrypted partition
624 616 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
625 617
626 618 # Open encrypted partition and setup mapping
627 619 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
628 620
629 621 # Secure delete password keyfile
630 622 shred -zu .password
631 623
632 624 # Update temporary loop device
633 625 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
634 626
635 627 # Wipe encrypted partition (encryption cipher is used for randomness)
636 628 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
637 629 fi
638 630
639 631 # Build filesystems
640 632 mkfs.vfat "$FRMW_LOOP"
641 633 mkfs.ext4 "$ROOT_LOOP"
642 634
643 635 # Mount the temporary loop devices
644 636 mkdir -p "$BUILDDIR/mount"
645 637 mount "$ROOT_LOOP" "$BUILDDIR/mount"
646 638
647 639 mkdir -p "$BUILDDIR/mount/boot/firmware"
648 640 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
649 641
650 642 # Copy all files from the chroot to the loop device mount point directory
651 643 rsync -a "${R}/" "$BUILDDIR/mount/"
652 644
653 645 # Unmount all temporary loop devices and mount points
654 646 cleanup
655 647
656 648 # Create block map file(s) of image(s)
657 649 if [ "$ENABLE_SPLITFS" = true ] ; then
658 650 # Create block map files for "bmaptool"
659 651 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
660 652 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
661 653
662 654 # Image was successfully created
663 655 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
664 656 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
665 657 else
666 658 # Create block map file for "bmaptool"
667 659 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
668 660
669 661 # Image was successfully created
670 662 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
671 663 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant